import { Chunk } from "../chunk/chunk";
import * as peg from "pegjs";
export interface ITraceEvent {
    type: "rule.enter" | "rule.fail" | "rule.match";
    rule: string;
    location: peg.LocationRange;
}
export interface ITracer {
    trace: (event: ITraceEvent) => void;
}
declare class Renderer {
    initializer: string;
    start: Chunk;
    grammar: Map<string, string>;
    rules: Map<string, Function>;
    actions: Map<string, Function>;
    tracer: ITracer;
    constructor(chunk: Chunk);
    render(): string;
    collectRule(chunk: Chunk): void;
}
declare class Parser {
    parser: peg.Parser;
    renderer: Renderer;
    grammar: string;
    constructor(renderer: Renderer);
    parse(code: string): any;
}
export interface IRenderConfig {
    tracer?: ITracer;
}
export declare function render(chunk: Chunk, config?: IRenderConfig): Parser;
export {};
